﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Cvicenie05_pondelok
{
    public class MagicOfDelegate
    {
        private delegate void MySexyDelegate(string s);
        private static void CallDel(MySexyDelegate del, string s) => del(s);

        public static void MyFirstDelegatePlay()
        {
            CallDel(Console.WriteLine, "Hello");

            MySexyDelegate del = null;
            // CallDel(del, "Hello");

            Console.WriteLine();
            del = Console.Write;
            del += Console.WriteLine;
            del += Console.WriteLine;
            del += Console.WriteLine;

            CallDel(del, "Hello");
        }

        public static void GenericCall(Action del) => del();
        public static void GenericCall(Action<string> del, string s) => del(s);
        public static void GenericCall(Func<string> del) => Console.WriteLine(del());
        public static void GenericCall(Func<string, string> del, string s)
            => Console.WriteLine(del(s));

        public static void AnonymouseMethods()
        {
            CallDel(delegate (string s)
            {
                Console.WriteLine(s);
                Console.WriteLine($"{s} hehehehe");
                Console.WriteLine($"hehehehe {s}");
            }, "Hello World!");

            MySexyDelegate dell = delegate (string s)
            {
                Console.WriteLine(s);
                Console.WriteLine($"{s} hehehehe");
                Console.WriteLine($"hehehehe {s}");
            };

            dell += Console.WriteLine;

            var list = new List<int> { 1, 2, 3, 4, 5 };
            var lst = list.FindAll(delegate (int item)
            {
                return (item % 2) == 1;
            });

            foreach (var item in lst)
                Console.WriteLine(item);
        }

        public static void LambdaPLays()
        {
            var list = new List<int> { 1, 2, 3, 4, 5 };
            // var lst = list.FindAll((int item) => (item % 2) == 1);
            var lst = list.FindAll(item => (item % 2) == 1);

            foreach (var item in lst)
                Console.WriteLine(item);

            Console.WriteLine("Hi");
            GenericCall(() => Console.WriteLine());
            Console.WriteLine("Hi");
            GenericCall(s => Console.WriteLine((s.Length > 10).ToString()), "blablabla");
            GenericCall(s => Console.WriteLine((s.Length > 10).ToString()), "bla bla bla bla");

            GenericCall(() => "Oh yeah");
            GenericCall(s => s + " I am already a big boi ...", "Mamaaaaa !!! ");
        }

    }
}
