﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Cvicenie05_pondelok
{
    public static class SpeciMethods
    {
        // List<int> {1, 2, 3, 4, 5, 6, 7 .... }
        // Console.WriteLine
        public static void ForEach<T>(this IEnumerable<T> collection, Action<T> action)
        {
            foreach (var element in collection)
                action(element);
        }

        public static void PrintPalindromes(this IEnumerable<string> words, Func<string, bool> isPalindromeFunc)
        {
            foreach (var word in words)
            {
                if (isPalindromeFunc(word))
                    Console.WriteLine($"{word}");
            }
        }

        public static IEnumerable<T> Where<T>(this IEnumerable<T> collection, Func<T, bool> condition)
        {
            foreach (var element in collection)
            {
                if (condition(element))
                    yield return element;
            }
        }
    }
}
